
import java.util.LinkedList; 
import java.lang.Integer; 
import java.util.Collections; 
import java.util.Comparator; 
import java.io.*; 

public    class  Graph {
	
    public LinkedList vertices;

	
    public static boolean isDirected = false;

	

	static
	{
		staticInitialization();	
	}

	

	private static void  staticInitialization__wrappee__Base  ()
	{
	}

	
	public static void staticInitialization()
	{
		staticInitialization__wrappee__Base();
		isDirected = false;
	}

	
   
    public Graph() {
        vertices = new LinkedList();
    }

	
 
    // Fall back method that stops the execution of programs
    private void  run__wrappee__DFS  ( Vertex s ) {}

	

    // Executes MSTPrim
    private void  run__wrappee__MSTPrim  ( Vertex s )
     {
        Graph gaux = Prim( s );
        Graph.stopProfile();
        gaux.display();
        Graph.resumeProfile();
        run__wrappee__DFS( s );
        CheckMST.checkMinimalSpanningTreeProperties(gaux);
      }

	

    // Executes Connected Components
    private void  run__wrappee__Connected  ( Vertex s )
     {
        ConnectedComponents();
        run__wrappee__MSTPrim( s );
    }

	

    // Executes Number Vertices
    public void run( Vertex s )
     {
        NumberVertices();
        run__wrappee__Connected( s );
    }

	
    // Adds an edge with weights
    public void addAnEdge  ( Vertex start,  Vertex end, int weight )
   {
        addEdge( start,end, weight );

    }

	
        
    public void addVertex( Vertex v ) {
        vertices.add( v );
    }

	
   
    // Adds and edge by setting end as adjacent to start vertices   
    private void  addEdge__wrappee__Base  ( Vertex start,  Vertex end ) {
        start.addAdjacent( end );
    }

	

   
    // Adds and edge by setting start as adjacent to end and
    // viceversa
    public void addEdge( Vertex start,  Vertex end )
    {
        addEdge__wrappee__Base(start, end);
	end.addAdjacent( start );
    }

	
      
    // Finds a vertex given its name in the vertices list
    public  Vertex findsVertex( String theName )
      {
        int i=0;
        Vertex theVertex;
        
        // if we are dealing with the root
        if ( theName==null )
            return null;
            
        for( i=0; i<vertices.size(); i++ )
            {
            theVertex = ( Vertex )vertices.get( i );
            if ( theName.equals( theVertex.name ) )
                return theVertex;
        }
        return null;
    }

	
    
    private void  display__wrappee__Undirected  () {
        int s = vertices.size();
        int i;
 
        Main.println( "******************************************" );
        Main.println( "Vertices " );
        for ( i=0; i<s; i++ )
            ( ( Vertex ) vertices.get( i ) ).display();
        Main.println( "******************************************" );

    }

	
    
    public void display() 
   {
        display__wrappee__Undirected();
    }

	
 
    public void addEdge( Vertex start,  Vertex end, int weight )
   {
        addEdge( start,end ); // adds the start and end as adjacent
        start.addWeight( weight ); // the direction layer takes care of that
                
        // if the graph is undirected you have to include 
        // the weight of the edge coming back
        if ( isDirected==false )
            end.addWeight( weight );


    }

	
    public void GraphSearch( WorkSpace w ) {
        int           s, c;
        Vertex  v;
  
        // Step 1: initialize visited member of all nodes

        s = vertices.size();
        if ( s == 0 )
            return;
         
        // Showing the initialization process
        for ( c = 0; c < s; c++ ) {
            v = ( Vertex ) vertices.get( c );
            v.init_vertex( w );
        }

        // Step 2: traverse adjacentVertices of each node
         
        for ( c = 0; c < s; c++ ) {
            v = ( Vertex ) vertices.get( c );
            if ( !v.visited ) {
                w.nextRegionAction( v );
		nodeSearch(v, w);
            }
        } //end for
         
    }

	 // GraphSearch

   	private void  nodeSearch__wrappee__Search  (Vertex v, WorkSpace w)
	{

	}

	
	public void nodeSearch(Vertex v, WorkSpace w)
	{
		nodeSearch__wrappee__Search(v, w);
		v.dftNodeSearch( w );
	}

	
     
    public  Graph Prim( Vertex r ) {
        Vertex root;
                
        root = r;
        int numvertices = vertices.size();
        int i;
        Vertex x;
        
        // 2. and 3. Initializes the vertices
        for ( i=0; i < numvertices; i++ )
        {
            x = ( Vertex )vertices.get( i );
            x.pred = null;
            x.key = Integer.MIN_VALUE;  // S.H. 4. DSR: MAX_VALUE -> MIN_VALUE
        }
                
        // 4. and 5.        
        root.key = 0;
        root.pred = null;
                                
        // 2. S <- empty set
                
        // 1. Queue <- V[G], copy the vertex in the graph in the priority queue
        LinkedList Queue = new LinkedList();
                
        for( i=0; i < numvertices; i++ )
        {
            x = ( Vertex )vertices.get( i );
            if ( x.key != 0 ) // this means, if this is not the root
                Queue.add( x );
        }
                
        // Inserts the root at the head of the queue
        Queue.addFirst( root );
                
        // 6. while Q!=0
        Vertex ucurrent;
        int j,k,l;
        int pos;
        LinkedList Uneighbors;
        Vertex u,v;

        int wuv;
        boolean isNeighborInQueue = false;
                
        while ( Queue.size()!=0 )
        {
            // 7. u <- Extract-Min(Q);
                 // since this an ordered queue the first element is the min            
            u = ( Vertex )Queue.removeFirst();
                                                                        
            // 8. for each vertex v adjacent to u
            Uneighbors = u.adjacentVertices;

            for( k=0; k < Uneighbors.size(); k++ )
             {
                v = ( Vertex )Uneighbors.get( k );

                // Check to see if the neighbor is in the queue
                isNeighborInQueue = false;
                                                                
                // if the Neighor is in the queue
                int indexNeighbor = Queue.indexOf( v );
                if ( indexNeighbor>=0 )
                    isNeighborInQueue=true;
                                                                
                wuv = ( ( Integer )u.weightsList.get( k ) ).intValue();
                                                                
                // 9. Relax (u,v w)
                if ( isNeighborInQueue && ( wuv < v.key ) )
                   {
                    v.key = wuv;
                    v.pred = u.name;
                    Uneighbors.set( k,v ); // adjust values in the adjacentVertices
                                                                                                    
                    // update the values of v in the queue
                    // if (indexNeighbor>=0) Queue.set(indexNeighbor,v);
                                                                                                    
                      // update the values of v in the queue                    
                         // Remove v from the Queue so that we can reinsert it
                    // in a new place according to its new value to keep
                    // the Linked List ordered
                    Object residue = Queue.remove( indexNeighbor );
                                                                                                    
                    // Get the new position for v
                    int position = Collections.binarySearch( Queue,v, 
                           new Comparator() {
                        public int compare( Object o1, Object o2 )
                                                   {
                            Vertex v1 = ( Vertex )o1;
                            Vertex v2 = ( Vertex )o2;
                                  
                            if ( v1.key < v2.key )
                                return -1;

                            if ( v1.key == v2.key )
                                return 0;
                            return 1;
                        }
                    } );
                                                                                                            
                    // Adds v in its new position in Queue                                                                                                      
                    if ( position < 0 )  // means it is not there
                             {
                        Queue.add( - ( position+1 ),v );
                    }
                    else      // means it is there
                             {
                        Queue.add( position,v );
                    }
                } // if 9. Relax
                                    
            } // for all adjacentVertices
        } // of while
                
        // Creates a new graph from the original vertices and the pred
        // fields
        String theName;
        Graph newGraph = new  Graph();
                
        // Creates and adds the vertices with the same name
        for ( i=0; i<numvertices; i++ )
      {
            theName = ( ( Vertex )vertices.get( i ) ).name;
            newGraph.addVertex( new  Vertex().assignName( theName ) );
        }
                
        Vertex theVertex, thePred;
        Vertex theNewVertex, theNewPred;
        Vertex theNeighbor;
        boolean flag = false;
      
        // adds the adjacent Vertices based on the pred fields
        for ( i=0; i<numvertices; i++ )
      {
            // theVertex and its predecessor
            theVertex = ( Vertex )vertices.get( i );
            thePred = findsVertex( theVertex.pred );
            
            // if theVertex is the source then continue we dont need
            // to create a new neighbor
            if ( thePred==null )
                continue;
            
            // Find the references in the new Graph
            theNewVertex = newGraph.findsVertex( theVertex.name );
            theNewPred = newGraph.findsVertex( thePred.name );
 
            // Creates the new neighbor in predecessor -> vertex in the new
            // Graph and adjusts the adorns based on the old edge
            ( theNewPred.adjacentVertices ).add( theNewVertex );
            
            // the adjacent corresponds to the neighbor formed with
            // theVertex -> thePred
            // find the corresponding neighbor of the Vertex, that is,
            // predecessor
            j=0;
            flag=false;
            do
          {
                theNeighbor = ( Vertex ) ( theVertex.adjacentVertices ).get( j );
                if ( theNeighbor.name.equals( thePred.name ) )
                    flag = true;
                else
                    j++;
            }
            while( flag==false && j < theVertex.adjacentVertices.size() );
           
            // What remains to be done is to adjust the adorns
            // by copying  the values that are embedded in 
            // theNeighbor object 
            theNewPred.adjustAdorns( theVertex, j );
               
        } // all the vertices
                                                                 
        return newGraph;
    }

	
     
    public void ConnectedComponents() {
        GraphSearch( new RegionWorkSpace() );
    }

	
     
    public void NumberVertices() {
        GraphSearch( new NumberWorkSpace() );
    }

	

    public Reader inFile;

	 // File handler for reading
    public static int ch;

	 // Character to read/write

    // timmings
    static long last=0, current=0, accum=0;

	

    public void runBenchmark( String FileName ) throws IOException
      {
        try {
            inFile = new FileReader( FileName );
        }
        catch ( IOException e )
        {
            Main.println( "Your file " + FileName +
                     " cannot be read" );
        }
    }

	

    public void stopBenchmark() throws IOException
      {
        inFile.close();
    }

	

    public int readNumber() throws IOException
      {
        int index =0;
        char[] word = new char[80];
        int ch=0;

        ch = inFile.read();
        while( ch==32 )
            ch = inFile.read(); // skips extra whitespaces

        // while it is not EOF, WS, NL
        while( ch!=-1 && ch!=32 && ch!=10 )
        {
            word[index++] = ( char )ch;
            ch = inFile.read();
        }
        word[index]=0;

        String theString = new String( word );

        theString = new String( theString.substring( 0,index ) ).trim();
        return Integer.parseInt( theString,10 );
    }

	

    public static void startProfile()
      {
        accum = 0;
        current = System.currentTimeMillis();
        last = current;
    }

	

    public static void stopProfile()
      {
        current = System.currentTimeMillis();
        accum = accum + ( current - last );
    }

	

    public static void resumeProfile()
      {
        current = System.currentTimeMillis();
        last = current;
    }

	

    public static void endProfile()
      {
        current = System.currentTimeMillis();
        accum = accum + ( current-last );
        //Main.println( "Time elapsed: "+ accum + " milliseconds" );
    }


}
